"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toJsonSchema = exports.fromJsonSchema = void 0;
var _registry = /*#__PURE__*/require("@traversable/registry");
var _schemaCore = /*#__PURE__*/require("@traversable/schema-core");
var _specification = /*#__PURE__*/require("./specification.js");
var _functor = /*#__PURE__*/require("./functor.js");
var to = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./jsonSchema.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const phantom = () => void 0;
/** @internal */
function handleOptionality(x) {
  let {
    [_registry.symbol.optional]: ix,
    ...y
  } = x;
  y = Recursive.fromJsonSchema(y);
  if (typeof ix !== 'number') return Recursive.fromJsonSchema(y);else while (ix-- > 0) y = _schemaCore.t.optional(y);
  return y;
}
var Recursive;
(function (Recursive) {
  Recursive.toJsonSchema = x => {
    switch (true) {
      default:
        return _registry.fn.exhaustive(x);
      case x.tag === _registry.URI.symbol:
        return phantom();
      case x.tag === _registry.URI.bigint:
        return phantom();
      case x.tag === _registry.URI.never:
        return phantom();
      case x.tag === _registry.URI.undefined:
        return phantom();
      case x.tag === _registry.URI.void:
        return phantom();
      case x.tag === _registry.URI.any:
        return _specification.JsonSchema.raw.any;
      case x.tag === _registry.URI.unknown:
        return _specification.JsonSchema.raw.any;
      case x.tag === _registry.URI.null:
        return _specification.JsonSchema.raw.null;
      case x.tag === _registry.URI.boolean:
        return _specification.JsonSchema.raw.boolean;
      case x.tag === _registry.URI.integer:
        return _specification.JsonSchema.raw.integer;
      case x.tag === _registry.URI.number:
        return _specification.JsonSchema.raw.number;
      case x.tag === _registry.URI.string:
        return _specification.JsonSchema.raw.string;
      case x.tag === _registry.URI.optional:
        return to.Optional({
          jsonSchema: x.def
        }).jsonSchema;
      case x.tag === _registry.URI.eq:
        return to.Eq(x.def).jsonSchema;
      case x.tag === _registry.URI.array:
        return to.Array({
          jsonSchema: x.def
        }).jsonSchema;
      case x.tag === _registry.URI.record:
        return to.Record({
          ...x,
          jsonSchema: x.def
        }).jsonSchema;
      case x.tag === _registry.URI.union:
        return to.Union(..._registry.fn.map(x.def, v => ({
          jsonSchema: v
        }))).jsonSchema;
      case x.tag === _registry.URI.intersect:
        return to.Intersect(..._registry.fn.map(x.def, v => ({
          jsonSchema: v
        }))).jsonSchema;
      case x.tag === _registry.URI.tuple:
        return to.Tuple(..._registry.fn.map(x.def, v => ({
          jsonSchema: v
        }))).jsonSchema;
      case x.tag === _registry.URI.object:
        return to.Object(_registry.fn.map(x.def, v => ({
          jsonSchema: v
        }))).jsonSchema;
    }
  };
  Recursive.fromJsonSchema = x => {
    switch (true) {
      default:
        return _registry.fn.exhaustive(x);
      case _registry.symbol.optional in x:
        return handleOptionality(x);
      case _specification.JsonSchema.null(x):
        return _schemaCore.t.null;
      case _specification.JsonSchema.boolean(x):
        return _schemaCore.t.boolean;
      case _specification.JsonSchema.integer(x):
        return _schemaCore.t.integer;
      case _specification.JsonSchema.number(x):
        return _schemaCore.t.number;
      case _specification.JsonSchema.string(x):
        return _schemaCore.t.string;
      case _specification.JsonSchema.record(x):
        return _schemaCore.t.record(x.additionalProperties);
      case _specification.JsonSchema.any(x):
        return _schemaCore.t.unknown;
      case _specification.JsonSchema.union(x):
        return _schemaCore.t.union.def(x.anyOf);
      case _specification.JsonSchema.enum(x):
        return _schemaCore.t.union.def(x.enum.map(_ => _schemaCore.t.eq(_)));
      case _specification.JsonSchema.const(x):
        return _schemaCore.t.eq(x.const);
      case _specification.JsonSchema.intersect(x):
        return _schemaCore.t.intersect.def(x.allOf);
      case _specification.JsonSchema.tuple(x):
        return _schemaCore.t.tuple.def(x.items);
      case _specification.JsonSchema.array(x):
        return _schemaCore.t.array.def(x.items);
      case _specification.JsonSchema.record(x):
        return _schemaCore.t.record.def(x.additionalProperties);
      case _specification.JsonSchema.object(x):
        return _schemaCore.t.object.def(_registry.fn.map(x.properties, (v, k) => x.required.includes(`${k}`) ? v : _schemaCore.t.optional(v)));
    }
  };
})(Recursive || (Recursive = {}));
const toJsonSchema = exports.toJsonSchema = /*#__PURE__*/_registry.fn.cata(_schemaCore.t.Functor)(Recursive.toJsonSchema);
const fromJsonSchema = exports.fromJsonSchema = /*#__PURE__*/_registry.fn.cata(_functor.Functor)(Recursive.fromJsonSchema);
//# sourceMappingURL=adapter.js.map