"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unfold = exports.fold = exports.Functor = void 0;
var _registry = /*#__PURE__*/require("@traversable/registry");
var _specification = /*#__PURE__*/require("./specification.js");
const Functor = exports.Functor = {
  map(f) {
    return x => {
      switch (true) {
        default:
          return _registry.fn.exhaustive(x);
        case _specification.JsonSchema.Nullary(x):
          return x;
        case _specification.JsonSchema.enum(x):
          return x;
        case _specification.JsonSchema.const(x):
          return x;
        case _specification.JsonSchema.union(x):
          return {
            ...x,
            anyOf: _registry.fn.map(x.anyOf, f)
          };
        case _specification.JsonSchema.intersect(x):
          return {
            ...x,
            allOf: _registry.fn.map(x.allOf, f)
          };
        case _specification.JsonSchema.tuple(x):
          return {
            ...x,
            items: _registry.fn.map(x.items, f)
          };
        case _specification.JsonSchema.array(x):
          return {
            ...x,
            items: f(x.items)
          };
        case _specification.JsonSchema.object(x):
          return {
            ...x,
            properties: _registry.fn.map(x.properties, f)
          };
        case _specification.JsonSchema.record(x):
          return {
            ...x,
            additionalProperties: f(x.additionalProperties)
          };
      }
    };
  }
};
const fold = exports.fold = /*#__PURE__*/_registry.fn.cata(Functor);
const unfold = exports.unfold = /*#__PURE__*/_registry.fn.ana(Functor);
//# sourceMappingURL=functor.js.map