"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.any = exports.JsonSchema = void 0;
var _schemaCore = /*#__PURE__*/require("@traversable/schema-core");
const RAW = {
  any: {
    type: 'object',
    properties: {},
    nullable: true
  },
  null: {
    type: 'null',
    enum: [null]
  },
  boolean: {
    type: 'boolean'
  },
  integer: {
    type: 'integer'
  },
  number: {
    type: 'number'
  },
  string: {
    type: 'string'
  }
};
const JsonSchema_any = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('object'),
  properties: /*#__PURE__*/_schemaCore.t.object({}),
  nullable: /*#__PURE__*/_schemaCore.t.eq(true)
});
const JsonSchema_null = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('null'),
  enum: /*#__PURE__*/_schemaCore.t.tuple(/*#__PURE__*/_schemaCore.t.eq(null))
});
const JsonSchema_boolean = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('boolean')
});
const JsonSchema_integer = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('integer')
});
const JsonSchema_number = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('number')
});
const JsonSchema_string = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('string')
});
const JsonSchema_const = /*#__PURE__*/_schemaCore.t.object({
  const: _schemaCore.t.unknown
});
const JsonSchema_enum = /*#__PURE__*/_schemaCore.t.object({
  enum: /*#__PURE__*/_schemaCore.t.array(_schemaCore.t.unknown, 'readonly')
});
const JsonSchema_array = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('array'),
  items: _schemaCore.t.unknown
});
const JsonSchema_record_ = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('object'),
  additionalProperties: _schemaCore.t.unknown
});
const JsonSchema_record = u => JsonSchema_record_(u);
const JsonSchema_union_ = /*#__PURE__*/_schemaCore.t.object({
  anyOf: /*#__PURE__*/_schemaCore.t.array(_schemaCore.t.unknown, 'readonly')
});
const JsonSchema_union = /*#__PURE__*/_schemaCore.t.inline(u => JsonSchema_union_(u));
const JsonSchema_intersect_ = /*#__PURE__*/_schemaCore.t.object({
  allOf: /*#__PURE__*/_schemaCore.t.array(_schemaCore.t.unknown, 'readonly')
});
const JsonSchema_intersect = /*#__PURE__*/_schemaCore.t.inline(u => JsonSchema_intersect_(u));
const JsonSchema_object = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('object'),
  required: /*#__PURE__*/_schemaCore.t.array(_schemaCore.t.string),
  properties: _schemaCore.t.unknown
});
const JsonSchema_tuple = /*#__PURE__*/_schemaCore.t.object({
  type: /*#__PURE__*/_schemaCore.t.eq('array'),
  items: _schemaCore.t.unknown,
  minItems: _schemaCore.t.number,
  maxItems: _schemaCore.t.number,
  additionalItems: /*#__PURE__*/_schemaCore.t.eq(false)
});
const Nullary = /*#__PURE__*/_schemaCore.t.union(JsonSchema_any, JsonSchema_null, JsonSchema_boolean, JsonSchema_integer, JsonSchema_number, JsonSchema_string);
const Special = /*#__PURE__*/_schemaCore.t.union(JsonSchema_enum, JsonSchema_const);
const Unary = /*#__PURE__*/_schemaCore.t.union(JsonSchema_array, JsonSchema_record, JsonSchema_union, JsonSchema_intersect, JsonSchema_tuple, JsonSchema_object);
var JsonSchema;
(function (JsonSchema) {
  JsonSchema.raw = RAW;
})(JsonSchema || (exports.JsonSchema = JsonSchema = {}));
const any = exports.any = JsonSchema_any;
/* data types */
JsonSchema.null = JsonSchema_null;
JsonSchema.boolean = JsonSchema_boolean;
JsonSchema.integer = JsonSchema_integer;
JsonSchema.number = JsonSchema_number;
JsonSchema.string = JsonSchema_string;
JsonSchema.any = JsonSchema_any;
JsonSchema.enum = JsonSchema_enum;
JsonSchema.const = JsonSchema_const;
JsonSchema.array = JsonSchema_array;
JsonSchema.record = JsonSchema_record;
JsonSchema.union = JsonSchema_union;
JsonSchema.intersect = JsonSchema_intersect;
JsonSchema.tuple = JsonSchema_tuple;
JsonSchema.object = JsonSchema_object;
/* terms */
JsonSchema.Nullary = Nullary;
JsonSchema.Unary = Unary;
JsonSchema.Special = Special;
//# sourceMappingURL=specification.js.map