import { symbol } from '@traversable/registry';
import type { MinItems } from './items.js';
import type { RequiredKeys } from './properties.js';
import { JsonSchema } from './specification.js';
export { minItems } from './items.js';
export { never_ as never, unknown_ as unknown, any_ as any, void_ as void, undefined_ as undefined, null_ as null, symbol_ as symbol, boolean_ as boolean, bigint_ as bigint, integer_ as integer, number_ as number, string_ as string, eq, optional, array, record, tuple, union, intersect, object_ as object, };
interface never_ {
    jsonSchema: void;
}
declare const never_: never_;
interface void_ {
    jsonSchema: void;
}
declare const void_: void_;
interface undefined_ {
    jsonSchema: void;
}
declare const undefined_: undefined_;
interface symbol_ {
    jsonSchema: void;
}
declare const symbol_: symbol_;
interface bigint_ {
    jsonSchema: void;
}
declare const bigint_: bigint_;
declare const any_: any_;
interface any_ {
    jsonSchema: typeof JsonSchema.raw.any;
}
declare const unknown_: unknown_;
interface unknown_ {
    jsonSchema: typeof JsonSchema.raw.any;
}
declare const null_: null_;
interface null_ {
    jsonSchema: typeof JsonSchema.raw.null;
}
declare const boolean_: boolean_;
interface boolean_ {
    jsonSchema: typeof JsonSchema.raw.boolean;
}
declare const integer_: integer_;
interface integer_ {
    jsonSchema: typeof JsonSchema.raw.integer;
}
declare const number_: number_;
interface number_ {
    jsonSchema: typeof JsonSchema.raw.number;
}
declare const string_: string_;
interface string_ {
    jsonSchema: typeof JsonSchema.raw.string;
}
interface eq<S> {
    jsonSchema: Evaluate<JsonSchema.const<S>>;
}
declare function eq<V>(value: V): eq<V>;
interface optional<S> {
    [symbol.optional]: true;
    jsonSchema: S['jsonSchema' & keyof S];
}
declare function optional<S>(x: S): optional<S>;
interface array<S> {
    jsonSchema: Evaluate<JsonSchema.array<S['jsonSchema' & keyof S]>>;
}
declare function array<S>(schema: S): array<S>;
interface record<S> {
    jsonSchema: Evaluate<JsonSchema.record<S['jsonSchema' & keyof S]>>;
}
declare function record<S>(schema: S): record<S>;
interface union<S extends readonly unknown[]> {
    jsonSchema: {
        anyOf: {
            [I in keyof S]: S[I]['jsonSchema' & keyof S[I]];
        };
    };
}
declare function union<S extends readonly unknown[]>(schemas: S): union<S>;
interface intersect<S extends readonly unknown[]> {
    jsonSchema: {
        allOf: {
            [I in keyof S]: S[I]['jsonSchema' & keyof S[I]];
        };
    };
}
declare function intersect<S extends readonly unknown[]>(schemas: S): intersect<S>;
interface tuple<S extends readonly unknown[]> {
    jsonSchema: {
        type: 'array';
        items: {
            [I in keyof S]: S[I]['jsonSchema' & keyof S[I]];
        };
        additionalItems: false;
        minItems: MinItems<S>;
        maxItems: S['length' & keyof S];
    };
}
declare function tuple<S extends readonly unknown[]>(schemas: readonly [...S]): tuple<S>;
interface object_<S extends {
    [x: string]: unknown;
}> {
    jsonSchema: {
        type: 'object';
        required: RequiredKeys<S>;
        properties: {
            [K in keyof S]: S[K]['jsonSchema' & keyof S[K]];
        };
    };
}
declare function object_<S extends {
    [x: string]: unknown;
}>(schemas: S): object_<S>;
//# sourceMappingURL=jsonSchema_.d.ts.map