import type { AnySchema, Schema, Unspecified } from '@traversable/schema-core';
import { t as T } from '@traversable/schema-core';
import * as _ from './jsonSchema.js';
import never_ = _.Never;
import void_ = _.Void;
import undefined_ = _.Undefined;
import symbol_ = _.Symbol;
import bigint_ = _.BigInt;
import inline_ = _.Inline;
import unknown_ = _.Unknown;
import any_ = _.Any;
import null_ = _.Null;
import boolean_ = _.Boolean;
import integer_ = _.Integer;
import number_ = _.Number;
import string_ = _.String;
import eq_ = _.Eq;
import optional_ = _.Optional;
import array_ = _.Array;
import record_ = _.Record;
import union_ = _.Union;
import intersect_ = _.Intersect;
import tuple_ = _.Tuple;
import object_ = _.Object;
import F = T.F;
import Fixpoint = T.Fixpoint;
import Free = T.Free;
import InvalidSchema = T.InvalidSchema;
import Leaf = T.Leaf;
import bottom = T.bottom;
import top = T.top;
import typeOf = T.typeOf;
export declare namespace t {
    export { typeOf, never_ as never, void_ as void, undefined_ as undefined, symbol_ as symbol, bigint_ as bigint, inline_ as inline, unknown_ as unknown, any_ as any, null_ as null, boolean_ as boolean, integer_ as integer, number_ as number, string_ as string, eq_ as eq, optional_ as optional, array_ as array, record_ as record, union_ as union, intersect_ as intersect, tuple_ as tuple, object_ as object, typeOf as typeof, F, Fixpoint, Free, InvalidSchema, Leaf, bottom, top, AnySchema, Schema, Unspecified, };
}
export declare namespace t {
    const Functor: import("@traversable/registry").Functor<T.Free, T.Fixpoint>;
    const fold: <T>(algebra: import("@traversable/registry").Algebra<T.Free, T>) => <S extends T.Fixpoint>(term: S) => T;
    const is: {
        readonly never: (u: unknown) => u is T.never;
        readonly any: (u: unknown) => u is T.any;
        readonly void: (u: unknown) => u is T.void;
        readonly unknown: (u: unknown) => u is T.unknown;
        readonly null: (u: unknown) => u is T.null;
        readonly undefined: (u: unknown) => u is T.undefined;
        readonly symbol: (u: unknown) => u is T.symbol;
        readonly boolean: (u: unknown) => u is T.boolean;
        readonly bigint: (u: unknown) => u is T.bigint;
        readonly integer: (u: unknown) => u is T.integer;
        readonly number: (u: unknown) => u is T.number;
        readonly string: (u: unknown) => u is T.string;
        readonly eq: <S>(u: S) => u is import("@traversable/registry").Conform<S, T.eq<any>, T.eq>;
        readonly array: <S>(u: S) => u is import("@traversable/registry").Conform<S, T.array<any>, T.array>;
        readonly record: <S>(u: S) => u is import("@traversable/registry").Conform<S, T.record<any>, T.record>;
        readonly optional: <S>(u: S) => u is import("@traversable/registry").Conform<S, T.optional<any>, T.optional>;
        readonly union: <S>(u: unknown) => u is import("@traversable/registry").Conform<S, T.union<any>, T.union>;
        readonly intersect: <S>(u: unknown) => u is import("@traversable/registry").Conform<S, T.intersect<any>, T.intersect>;
        readonly tuple: <S>(u: S) => u is import("@traversable/registry").Conform<S, T.tuple<any>, T.tuple>;
        readonly object: <S>(u: unknown) => u is import("@traversable/registry").Conform<S, T.object<any>, T.object>;
    };
    const isLeaf: (u: unknown) => u is Leaf;
    const unfold: <T>(coalgebra: import("@traversable/registry").Coalgebra<T.Free, T>) => <S extends T.Fixpoint>(expr: S) => T.F<T>;
}
//# sourceMappingURL=schema.d.ts.map