import type { HKT } from '@traversable/registry';
import { t } from '@traversable/schema-core';
interface JsonSchema_any {
    type: 'object';
    properties: {};
    nullable: true;
}
declare const JsonSchema_any: t.object<{
    type: t.eq<"object">;
    properties: t.object<{}>;
    nullable: t.eq<true>;
}>;
interface JsonSchema_null {
    type: 'null';
    enum: [null];
}
declare const JsonSchema_null: t.object<{
    type: t.eq<"null">;
    enum: t.tuple<[t.eq<null>]>;
}>;
interface JsonSchema_boolean {
    type: 'boolean';
}
declare const JsonSchema_boolean: t.object<{
    type: t.eq<"boolean">;
}>;
interface JsonSchema_integer {
    type: 'integer';
}
declare const JsonSchema_integer: t.object<{
    type: t.eq<"integer">;
}>;
interface JsonSchema_number {
    type: 'number';
}
declare const JsonSchema_number: t.object<{
    type: t.eq<"number">;
}>;
interface JsonSchema_string {
    type: 'string';
}
declare const JsonSchema_string: t.object<{
    type: t.eq<"string">;
}>;
interface JsonSchema_const<T = unknown> {
    const: T;
}
declare const JsonSchema_const: t.object<{
    const: t.unknown;
}>;
interface JsonSchema_enum<T = unknown> {
    enum: readonly T[];
}
declare const JsonSchema_enum: t.object<{
    enum: t.ReadonlyArray<t.unknown>;
}>;
interface JsonSchema_array<T> {
    type: 'array';
    items: T;
}
declare const JsonSchema_array: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
}>;
interface JsonSchema_record<T = unknown> {
    type: 'object';
    additionalProperties: T;
}
declare const JsonSchema_record: <T>(u: unknown) => u is JsonSchema_record<T>;
interface JsonSchema_union<T = unknown> {
    anyOf: T;
}
declare const JsonSchema_union: t.inline<JsonSchema_union<unknown>>;
interface JsonSchema_intersect<T = unknown> {
    allOf: T;
}
declare const JsonSchema_intersect: t.inline<JsonSchema_intersect<unknown>>;
interface JsonSchema_object<T> {
    type: 'object';
    required: string[];
    properties: T;
}
declare const JsonSchema_object: t.object<{
    type: t.eq<"object">;
    required: t.array<t.string>;
    properties: t.unknown;
}>;
interface JsonSchema_tuple<T> {
    type: 'array';
    items: T;
    minItems: number;
    maxItems: number;
    additionalItems: false;
}
declare const JsonSchema_tuple: t.object<{
    type: t.eq<"array">;
    items: t.unknown;
    minItems: t.number;
    maxItems: t.number;
    additionalItems: t.eq<false>;
}>;
type Nullary = JsonSchema_any | JsonSchema_null | JsonSchema_boolean | JsonSchema_integer | JsonSchema_number | JsonSchema_string;
type Unary<T> = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<T> | JsonSchema_record<T> | JsonSchema_union<readonly T[]> | JsonSchema_intersect<readonly T[]> | JsonSchema_tuple<readonly T[]> | JsonSchema_object<{
    [x: string]: T;
}>;
type Fixpoint = Nullary | JsonSchema_const | JsonSchema_enum | JsonSchema_array<Fixpoint> | JsonSchema_record<Fixpoint> | JsonSchema_union<readonly Fixpoint[]> | JsonSchema_intersect<readonly Fixpoint[]> | JsonSchema_tuple<readonly Fixpoint[]> | JsonSchema_object<{
    [x: string]: Fixpoint;
}>;
interface Free extends HKT {
    [-1]: Unary<this[0]>;
}
declare const Nullary: t.union<[t.object<{
    type: t.eq<"object">;
    properties: t.object<{}>;
    nullable: t.eq<true>;
}>, t.object<{
    type: t.eq<"null">;
    enum: t.tuple<[t.eq<null>]>;
}>, t.object<{
    type: t.eq<"boolean">;
}>, t.object<{
    type: t.eq<"integer">;
}>, t.object<{
    type: t.eq<"number">;
}>, t.object<{
    type: t.eq<"string">;
}>]>;
declare const Special: t.union<[t.object<{
    enum: t.ReadonlyArray<t.unknown>;
}>, t.object<{
    const: t.unknown;
}>]>;
declare const Unary: t.union<[t.object<{
    type: t.eq<"array">;
    items: t.unknown;
}>, <T>(u: unknown) => u is JsonSchema_record<T>, t.inline<JsonSchema_union<unknown>>, t.inline<JsonSchema_intersect<unknown>>, t.object<{
    type: t.eq<"array">;
    items: t.unknown;
    minItems: t.number;
    maxItems: t.number;
    additionalItems: t.eq<false>;
}>, t.object<{
    type: t.eq<"object">;
    required: t.array<t.string>;
    properties: t.unknown;
}>]>;
export declare namespace JsonSchema {
    export { JsonSchema_any as any, JsonSchema_null as null, JsonSchema_boolean as boolean, JsonSchema_integer as integer, JsonSchema_number as number, JsonSchema_string as string, JsonSchema_const as const, JsonSchema_enum as enum, JsonSchema_array as array, JsonSchema_record as record, JsonSchema_union as union, JsonSchema_intersect as intersect, JsonSchema_object as object, JsonSchema_tuple as tuple, Fixpoint, Free, Nullary, Unary, Special, };
}
export declare namespace JsonSchema {
    const raw: {
        any: {
            type: "object";
            properties: {};
            nullable: true;
        };
        null: {
            type: "null";
            enum: [null];
        };
        boolean: {
            type: "boolean";
        };
        integer: {
            type: "integer";
        };
        number: {
            type: "number";
        };
        string: {
            type: "string";
        };
    };
}
export declare const any: t.object<{
    type: t.eq<"object">;
    properties: t.object<{}>;
    nullable: t.eq<true>;
}>;
export {};
//# sourceMappingURL=specification.d.ts.map